;********************************************************************
;Procedure   : CerchioPlus
;Versione    : 1.0.0
;
;Autore      : Roberto Rossi
;Descrizione : questo comando permette di disegnare un cerchio
;              con in aggiunta la possibilit di indicarne il colore
;              ed il layer (piano) di appartenenza
;********************************************************************
(defun c:CerchioPlus ( / punto1 raggio colore layer)
(princ "\nComando CerchioPlus V.1.0.0")
(setq colore nil)

(initget 1)
(setq punto1 (getpoint "\nIndicare centro del cerchio : "))

(initget 35)
(setq raggio (getdist punto1 "\nIndicare raggio del cerchio : "))

(while (not colore)
  (initget 4)
  (setq colore (getint "\nIndicare colore cerchio [Invio per lista colori] : "))
  (if (not colore)
    (setq colore (acad_colordlg 256))
  );endif
);endw

(cond
  ((= colore 256)
    (setq colore "BYLAYER")
  )
  ((= colore 0)
    (setq colore "BYBLOCK")
  )
  ((> colore 256)
    (princ "\nIl colore indicato non  valido, il cerchio assumer il colore attivo.")
    (setq colore nil)
  )
);endc

(setq layer (getstring "\nIndicare layer di appartenenza : <0> "))
(if (not layer)
  (setq layer "0")
);endif

(command "_circle" punto1 raggio)
(if colore
  (command "_chprop" "_last" "" "_c" colore "")
);endif
(command "_chprop" "_last" "" "_la" layer "")
(prin1)
);enddef
